>From 4c8dbca556bee9c16b54931c9922b1bbb030641b Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Thu, 17 Jan 2013 15:41:41 -0500
Subject: [PATCH] Ticket 419 - REST interface for cert requests

---
 .../src/com/netscape/certsrv/cert/CertClient.java  |   6 +
 .../src/com/netscape/cmstools/cert/CertCLI.java    |   1 +
 .../netscape/cmstools/cert/CertRequestFindCLI.java | 144 +++++++++++++++++++++
 3 files changed, 151 insertions(+)
 create mode 100644 base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java

diff --git a/base/common/src/com/netscape/certsrv/cert/CertClient.java b/base/common/src/com/netscape/certsrv/cert/CertClient.java
index d8fd346587006003cc486e2b52a437c03a34c585..c209bf9b8c805634b8c977e4599f7e690e397d12 100644
--- a/base/common/src/com/netscape/certsrv/cert/CertClient.java
+++ b/base/common/src/com/netscape/certsrv/cert/CertClient.java
@@ -83,4 +83,10 @@ public class CertClient extends PKIClient {
     public void approveRequest(RequestId id, CertReviewResponse data) {
         certRequestResource.approveRequest(id, data);
     }
+
+    public CertRequestInfos listRequests(String requestState, String requestType, RequestId start, Integer pageSize,
+            Integer maxResults, Integer maxTime) {
+        return certRequestResource.listRequests(requestState, requestType, start, pageSize, maxResults, maxTime);
+    }
+
 }
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertCLI.java
index 034a12649441291f4d0f196b03bed862a9e4ce82..d3bf51e3232477ecedffc049a73cb516dff0c330 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertCLI.java
@@ -48,6 +48,7 @@ public class CertCLI extends CLI {
         addModule(new CertRevokeCLI(this));
         addModule(new CertHoldCLI(this));
         addModule(new CertReleaseHoldCLI(this));
+        addModule(new CertRequestFindCLI(this));
         addModule(new CertRequestSubmitCLI(this));
         addModule(new CertRequestReviewCLI(this));
         addModule(new CertRequestApproveCLI(this));
diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..5d66a24837cd2f7ac9cb8108882b995e3502f113
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestFindCLI.java
@@ -0,0 +1,144 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2012 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+
+package com.netscape.cmstools.cert;
+
+import org.apache.commons.cli.CommandLine;
+import org.apache.commons.cli.Option;
+import org.apache.commons.cli.ParseException;
+
+import com.netscape.certsrv.base.PKIException;
+import com.netscape.certsrv.cert.CertRequestInfo;
+import com.netscape.certsrv.cert.CertRequestInfos;
+import com.netscape.certsrv.request.RequestId;
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+/**
+ * @author Ade Lee
+ */
+public class CertRequestFindCLI extends CLI {
+    public CertCLI parent;
+
+    public CertRequestFindCLI(CertCLI parent) {
+        super("request-find", "Find certificate requests");
+        this.parent = parent;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(parent.name + "-" + name + " [OPTIONS...]", options);
+    }
+
+    public void execute(String[] args) throws Exception {
+
+        addOptions();
+
+        CommandLine cmd = null;
+        CertRequestInfos certRequests = null;
+        try {
+            cmd = parser.parse(options, args);
+        } catch (ParseException e) {
+            System.err.println("Error: " + e.getMessage());
+            printHelp();
+            System.exit(-1);
+        }
+
+        if (cmd.hasOption("help")) {
+            printHelp();
+            System.exit(-1);
+        }
+
+        String s = cmd.getOptionValue("start");
+        RequestId start = s == null ? null : new RequestId(s);
+
+        s = cmd.getOptionValue("size");
+        Integer size = s == null ? null : Integer.valueOf(s);
+
+        s = cmd.getOptionValue("maxResults");
+        Integer maxResults = s == null ? null : Integer.valueOf(s);
+
+        s = cmd.getOptionValue("maxTime");
+        Integer maxTime = s == null ? null : Integer.valueOf(s);
+
+        String requestState = cmd.getOptionValue("state");
+        if (requestState != null && requestState.equals("all")) requestState = null;
+
+        String requestType = cmd.getOptionValue("type");
+        if (requestType != null && requestType.equals("all")) requestType = null;
+
+        try {
+            certRequests = parent.client.certRequestResource.listRequests(requestState, requestType, start, size, maxResults, maxTime);
+        } catch (PKIException e) {
+            System.err.println("Error: Cannot list certificate requests. " + e.getMessage());
+            System.exit(-1);
+        }
+        if (certRequests.getRequests() == null || certRequests.getRequests().isEmpty()) {
+            MainCLI.printMessage("No matches found.");
+            System.exit(-1);
+        }
+
+        boolean first = true;
+        for (CertRequestInfo certRequest : certRequests.getRequests()) {
+            if (first) {
+                first = false;
+            } else {
+                System.out.println();
+            }
+
+            CertCLI.printCertRequestInfo(certRequest);
+        }
+
+        MainCLI.printMessage("Number of entries returned " + certRequests.getRequests().size());
+    }
+
+    public void addOptions() {
+
+        Option option = null;
+
+        // request state
+        option = new Option(null, "state", true, "Request state (pending, cancelled, rejected, complete, all)");
+        option.setArgName("state");
+        options.addOption(option);
+
+        // request type
+        option = new Option(null, "type", true, "Request type (enrollment, renewal, revocation, all)");
+        option.setArgName("type");
+        options.addOption(option);
+
+        //pagination options
+        option = new Option(null, "start", true, "Page start");
+        option.setArgName("start");
+        options.addOption(option);
+
+        option = new Option(null, "size", true, "Page size");
+        option.setArgName("size");
+        options.addOption(option);
+
+        //search limits
+        option = new Option(null, "maxResults", true, "Maximum number of results");
+        option.setArgName("maxResults");
+        options.addOption(option);
+
+        option = new Option(null, "timeout", true, "Search timeout");
+        option.setArgName("maxTime");
+        options.addOption(option);
+
+        //help
+        options.addOption(null, "help", false, "Show help options");
+    }
+}
-- 
1.7.11.7